﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Transactions;
using System.Data.Common;
using System.Data.Objects;
using System.Data.Mapping;
using peopleModel;

namespace ProcedureProj
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                using (TransactionScope sc = new TransactionScope())
                using (peopleEntities ents = new peopleEntities())
                {
                    Console.WriteLine("Before...");
                    ObjectQuery<person> oq = ents.CreateQuery<person>(
                        "SELECT VALUE p FROM person AS p");
                    foreach (person p in oq)
                    {
                        Console.WriteLine("{0}\t{1}\t{2}\t{3}", p.id, p.lastname, p.firstname, p.age);
                        if (p.lastname == "Smith")
                        {
                            // delete
                            p.Delete();
                        }
                        if (p.lastname == "Jones")
                        {
                            // update
                            p.age = 89;
                        }
                    }
                    // add - hardcoded key
                    person newp = new person(3);
                    newp.firstname = "Fred";
                    newp.lastname = "Jacobs";
                    newp.age = 42;
                    ents.AddObject(newp);
                    
                    ents.SaveChanges();
                    sc.Complete();

                    Console.WriteLine("After...");
                    foreach (person p in oq)
                        Console.WriteLine("{0}\t{1}\t{2}\t{3}", p.id, p.lastname, p.firstname, p.age);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
                if (ex.InnerException != null)
                    Console.WriteLine(ex.InnerException.Message);
            }

        }
    }
}
